## souffle-2.5.tar.gz

=== CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

cmake_minimum_required(VERSION 3.15)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(CMakeDependentOption)

option(SOUFFLE_GIT "Enable/Disable git completion" ON)

if (SOUFFLE_GIT)
    find_package(Git REQUIRED)

    # GIT_TAGNAME identifies the current commit, it is closest tag in the
    # branch, possibly followed by number of additionnal commits and
    # abbreviated hash
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --always
                    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                    RESULT_VARIABLE GIT_RESULT
                    OUTPUT_VARIABLE GIT_TAGNAME)

    # GIT_CLOSEST_TAG is the closest tag in the branch
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tags --always --abbrev=0
                    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                    RESULT_VARIABLE GIT_RESULT
                    OUTPUT_VARIABLE GIT_CLOSEST_TAG)

    # Figure out the version number, depends on whether building from the git repo
    if (NOT GIT_RESULT EQUAL 0)
        # Not building from a git clone
        message(WARNING "Unable to find git repository: version number will be incomplete")
        set(GIT_PACKAGE_VERSION "UNKNOWN")
        set(PACKAGE_VERSION "")
    else()
        string(REGEX REPLACE "\n$" "" GIT_PACKAGE_VERSION "${GIT_TAGNAME}")
        message(STATUS "Building souffle version ${GIT_PACKAGE_VERSION}")

        string(REGEX REPLACE "\n$" "" GIT_CLOSEST_TAG "${GIT_CLOSEST_TAG}")
        # remove leading 'v' in tag if any
        string(REGEX REPLACE "^v" "" PACKAGE_VERSION "${GIT_CLOSEST_TAG}")
        # remove trailing '-something' in tag
        string(REGEX REPLACE "-.*$" "" PACKAGE_VERSION "${PACKAGE_VERSION}")

        # If building from a shallow clone where tag is not available.
        if (NOT ${PACKAGE_VERSION} MATCHES "^[0-9.]+$")
            message(WARNING "Cannot find a valid tag: cmake project version will be incomplete")
            set(PACKAGE_VERSION "")
        endif()

        message(STATUS "Package version ${PACKAGE_VERSION}")
    endif()
endif()

project(souffle VERSION "${PACKAGE_VERSION}"
                DESCRIPTION "A datalog compiler"
                LANGUAGES CXX)
include(CTest)

# Require out-of-source builds
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
    message(FATAL_ERROR "You cannot build in a source directory (or any directory with a CMakeLists.txt file). Please make a build subdirectory. Feel free to remove CMakeCache.txt and CMakeFiles.")
endif()


if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
        "Choose the type of build" FORCE)
endif()
message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")

# Tells us whether we're building souffle as a main project
# or a subprobject
if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(SOUFFLE_MASTER_PROJECT On)
else()
    set(SOUFFLE_MASTER_PROJECT Off)
endif()

if (SOUFFLE_MASTER_PROJECT AND BUILD_TESTING)
    set(SOUFFLE_ENABLE_TESTING_DEFAULT ON)
else()
    set(SOUFFLE_ENABLE_TESTING_DEFAULT OFF)
endif()

# --------------------------------------------------
# User options available from the command line/cache
# --------------------------------------------------
option(SOUFFLE_DOMAIN_64BIT "Enable/Disable 64-bit number values in Datalog tuples" OFF)
option(SOUFFLE_USE_CURSES "Enable/Disable ncurses-based provenance display" ON)
option(SOUFFLE_SWIG "Enable/Disable all SWIG builds" OFF)
option(SOUFFLE_SWIG_PYTHON "Enable/Disable Python SWIG" OFF)
option(SOUFFLE_SWIG_JAVA "Enable/Disable Java SWIG" OFF)
option(SOUFFLE_USE_ZLIB "Enable/Disable use of libz file compression" ON)
option(SOUFFLE_USE_SQLITE "Enable/Disable use sqlite IO" ON)
option(SOUFFLE_USE_OPENMP "Enable/Disable use of openmp if available" ON)
option(SOUFFLE_SANITISE_MEMORY "Enable/Disable memory sanitiser" OFF)
option(SOUFFLE_SANITISE_THREAD "Enable/Disable thread sanitiser" OFF)
# SOUFFLE_NDEBUG = ON means -DNDEBUG on the compiler command line = no cassert
# Therefor SOUFFLE_NDEBUG = OFF means keep asserts
option(SOUFFLE_NDEBUG "Enable/Disable runtime checks even in release mode" OFF)
# By default, the "test/example" directory is not part of testing
# this flag enables the tests to run
option(SOUFFLE_TEST_EXAMPLES "Enable/Disable testing of code examples in tests/examples" OFF)
option(SOUFFLE_TEST_EVALUATION "Enable/Disable testing of evaluation examples in tests/examples" ON)
option(SOUFFLE_ENABLE_TESTING "Enable/Disable testing" ${SOUFFLE_ENABLE_TESTING_DEFAULT})
option(SOUFFLE_GENERATE_DOXYGEN "Generate Doxygen files (html;htmlhelp;man;rtf;xml;latex)" "")
option(SOUFFLE_CODE_COVERAGE "Enable coverage reporting" OFF)
option(SOUFFLE_BASH_COMPLETION "Enable/Disable bash completion" OFF)
option(SOUFFLE_USE_LIBFFI "Enable/Disable use of libffi" ON)
option(SOUFFLE_CUSTOM_GETOPTLONG "Enable/Disable custom getopt_long implementation" OFF)
option(SOUFFLE_TEST_DEBUG_REPORT "Enable/Disable generating debug-report for all tests" OFF)

cmake_dependent_option(SOUFFLE_USE_LIBCPP "Link to libc++ instead of libstdc++" ON
    "CMAKE_CXX_COMPILER_ID STREQUAL Clang" OFF)

# Using Clang? Likely want to use `lld` too.
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fuse-ld=lld")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fuse-ld=lld")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fuse-ld=lld")
endif()

# Add aditional modules to CMake
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

if (SOUFFLE_USE_LIBCPP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lc++abi")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lc++abi")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lc++abi")
endif()

if (WIN32)
  # Search libraries with and without 'lib' prefix.
  set(CMAKE_FIND_LIBRARY_PREFIXES ";lib")

  # Prefix all shared libraries with 'lib'.
  set(CMAKE_SHARED_LIBRARY_PREFIX "lib")

  # Prefix all static libraries with 'lib'.
  set(CMAKE_STATIC_LIBRARY_PREFIX "lib")

  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG "${OUTPUT_DIRECTORY}")
  SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE "${OUTPUT_DIRECTORY}")
  SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG "${OUTPUT_DIRECTORY}")
  SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE "${OUTPUT_DIRECTORY}")
  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG "${OUTPUT_DIRECTORY}")
  SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE "${OUTPUT_DIRECTORY}")
endif ()


if(EMSCRIPTEN)
  set(SOUFFLE_USE_SQLITE off)
  set(SOUFFLE_USE_OPENMP off)
  set(SOUFFLE_USE_ZLIB off)
  set(SOUFFLE_USE_LIBFFI off)
  set(SOUFFLE_USE_CURSES off)
  set(SOUFFLE_ENABLE_TESTING off)
endif ()
# --------------------------------------------------
# curses libraries for Provenance information
# --------------------------------------------------
if (SOUFFLE_USE_CURSES)
    find_package(Curses REQUIRED)
    if(NOT TARGET Curses::NCurses)
        add_library(Curses::NCurses UNKNOWN IMPORTED)
        set_target_properties(Curses::NCurses PROPERTIES
            IMPORTED_LOCATION "${CURSES_NCURSES_LIBRARY}"
            INTERFACE_INCLUDE_DIRECTORIES "${CURSES_INCLUDE_DIR}"
        )
    endif()
endif()

# --------------------------------------------------
# swig support
# --------------------------------------------------
if (SOUFFLE_SWIG)
    # Enable both
    set(SOUFFLE_SWIG_PYTHON "ON" CACHE STRING "" FORCE)
    set(SOUFFLE_SWIG_JAVA "ON" CACHE STRING "" FORCE)
endif()

if (SOUFFLE_SWIG_PYTHON OR SOUFFLE_SWIG_JAVA)
    find_package(SWIG REQUIRED)

    if (SOUFFLE_SWIG_PYTHON)
        find_package(Python3 3.7 REQUIRED)
    endif()

    if (SOUFFLE_SWIG_JAVA)
        find_package(Java REQUIRED
                     COMPONENTS Development)
        find_package(JNI REQUIRED)
        list(APPEND SOUFFLE_JAVA_INCLUDE_PATH ${JAVA_INCLUDE_PATH})
        list(APPEND SOUFFLE_JAVA_INCLUDE_PATH ${JAVA_INCLUDE_PATH2})
    endif()
endif()

# --------------------------------------------------
# flex and bison
# --------------------------------------------------
# See issue #2143.
if (CMAKE_HOST_SYSTEM_NAME MATCHES "Darwin")
    execute_process(
            COMMAND brew --prefix bison
            RESULT_VARIABLE BREW_BISON
            OUTPUT_VARIABLE BREW_BISON_PREFIX
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if (BREW_BISON EQUAL 0 AND EXISTS "${BREW_BISON_PREFIX}")
        message(STATUS "Found Bison keg installed by Homebrew at ${BREW_BISON_PREFIX}")
        set(BISON_EXECUTABLE "${BREW_BISON_PREFIX}/bin/bison")
    endif()

    execute_process(
            COMMAND brew --prefix flex
            RESULT_VARIABLE BREW_FLEX
            OUTPUT_VARIABLE BREW_FLEX_PREFIX
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if (BREW_FLEX EQUAL 0 AND EXISTS "${BREW_FLEX_PREFIX}")
        message(STATUS "Found Flex keg installed by Homebrew at ${BREW_FLEX_PREFIX}")
        set(FLEX_EXECUTABLE "${BREW_FLEX_PREFIX}/bin/flex")
    endif()
endif()
find_package(FLEX REQUIRED)
find_package(BISON "3.2" REQUIRED)

# --------------------------------------------------
# mcpp
# --------------------------------------------------
find_program(MCPP mcpp)

# --------------------------------------------------
# libz
# --------------------------------------------------
if (SOUFFLE_USE_ZLIB)
    find_package(ZLIB REQUIRED)
    if (SOUFFLE_ENABLE_TESTING)
        find_program(GZIP_BINARY gzip REQUIRED)
    endif()
endif()

# --------------------------------------------------
# sqlite
# --------------------------------------------------
if (SOUFFLE_USE_SQLITE)
    find_package(SQLite3 REQUIRED)
    if (SOUFFLE_ENABLE_TESTING)
        find_program(SQLITE3_BINARY sqlite3 REQUIRED)
    endif()
endif()

# --------------------------------------------------
# libffi
# --------------------------------------------------
if (SOUFFLE_USE_LIBFFI)
  find_package(libffi CONFIG QUIET)
  if (NOT libffi_FOUND)
    find_package(LibFFI REQUIRED)
  endif()
endif()

# --------------------------------------------------
# pthreads
# --------------------------------------------------
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# --------------------------------------------------
# OpenMP
# --------------------------------------------------
if (SOUFFLE_USE_OPENMP)
  find_package(OpenMP)
endif()

# --------------------------------------------------
# Memory Sanitiser
# --------------------------------------------------
if (SOUFFLE_SANITISE_MEMORY)
    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address,leak,undefined")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,leak,undefined")
    else()
        set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address,leak")
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address,leak")
    endif()
endif()

# --------------------------------------------------
# Thread Sanitiser
# --------------------------------------------------
if (SOUFFLE_SANITISE_THREAD)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")
endif()

# --------------------------------------------------
# Doxygen
# --------------------------------------------------
if (SOUFFLE_GENERATE_DOXYGEN)
    find_package(Doxygen REQUIRED dot)
    set(DOXYGEN_IN "${PROJECT_SOURCE_DIR}/doxygen.in")
    set(DOXYGEN_CFG "${PROJECT_SOURCE_DIR}/Doxyfile")
    set(DOXYGEN_DIR "${PROJECT_SOURCE_DIR}/doc")

    if ("htmlhelp" IN_LIST SOUFFLE_GENERATE_DOXYGEN)

=== src/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt


set(SOUFFLE_SOURCES
    FunctorOps.cpp
    Global.cpp
    GraphUtils.cpp
    MainDriver.cpp
    ast/Annotation.cpp
    ast/Aggregator.cpp
    ast/IntrinsicAggregator.cpp
    ast/UserDefinedAggregator.cpp
    ast/AlgebraicDataType.cpp
    ast/AliasType.cpp
    ast/Atom.cpp
    ast/Attribute.cpp
    ast/BinaryConstraint.cpp
    ast/BooleanConstraint.cpp
    ast/BranchType.cpp
    ast/BranchInit.cpp
    ast/Clause.cpp
    ast/SubsumptiveClause.cpp
    ast/Component.cpp
    ast/ComponentInit.cpp
    ast/ComponentType.cpp
    ast/Constant.cpp
    ast/Counter.cpp
    ast/Directive.cpp
    ast/ExecutionOrder.cpp
    ast/ExecutionPlan.cpp
    ast/FunctorDeclaration.cpp
    ast/FunctionalConstraint.cpp
    ast/IntrinsicFunctor.cpp
    ast/IterationCounter.cpp
    ast/Lattice.cpp
    ast/Negation.cpp
    ast/NilConstant.cpp
    ast/Node.cpp
    ast/NumericConstant.cpp
    ast/Pragma.cpp
    ast/Program.cpp
    ast/QualifiedName.cpp
    ast/RecordInit.cpp
    ast/RecordType.cpp
    ast/Relation.cpp
    ast/StringConstant.cpp
    ast/SubsetType.cpp
    ast/Term.cpp
    ast/TokenTree.cpp
    ast/TranslationUnit.cpp
    ast/Type.cpp
    ast/TypeCast.cpp
    ast/UnionType.cpp
    ast/UnnamedVariable.cpp
    ast/UserDefinedFunctor.cpp
    ast/Variable.cpp
    ast/analysis/Aggregate.cpp
    ast/analysis/ClauseNormalisation.cpp
    ast/analysis/ComponentLookup.cpp
    ast/analysis/Functor.cpp
    ast/analysis/Ground.cpp
    ast/analysis/IOType.cpp
    ast/analysis/PrecedenceGraph.cpp
    ast/analysis/ProfileUse.cpp
    ast/analysis/RecursiveClauses.cpp
    ast/analysis/RedundantRelations.cpp
    ast/analysis/RelationSchedule.cpp
    ast/analysis/JoinSize.cpp
    ast/analysis/SCCGraph.cpp
    ast/analysis/TopologicallySortedSCCGraph.cpp
    ast/analysis/typesystem/PolymorphicObjects.cpp
    ast/analysis/typesystem/SumTypeBranches.cpp
    ast/analysis/typesystem/Type.cpp
    ast/analysis/typesystem/TypeConstraints.cpp
    ast/analysis/typesystem/TypeConstrainsAnalysis.cpp
    ast/analysis/typesystem/TypeConstrainsAnalysis.h
    ast/analysis/typesystem/TypeSystem.cpp
    ast/analysis/typesystem/TypeEnvironment.cpp
    ast/transform/AddNullariesToAtomlessAggregates.cpp
    ast/transform/ComponentChecker.cpp
    ast/transform/ComponentInstantiation.cpp
    ast/transform/DebugReporter.cpp
    ast/transform/DebugDeltaRelation.cpp
    ast/transform/ExecutionPlanChecker.cpp
    ast/transform/ExpandEqrels.cpp
    ast/transform/FoldAnonymousRecords.cpp
    ast/transform/GroundedTermsChecker.cpp
    ast/transform/GroundWitnesses.cpp
    ast/transform/InlineRelations.cpp
    ast/transform/InsertLatticeOperations.cpp
    ast/transform/MagicSet.cpp
    ast/transform/MaterializeAggregationQueries.cpp
    ast/transform/MaterializeSingletonAggregation.cpp
    ast/transform/Meta.cpp
    ast/transform/MinimiseProgram.cpp
    ast/transform/NameUnnamedVariables.cpp
    ast/transform/NormaliseGenerators.cpp
    ast/transform/PartitionBodyLiterals.cpp
    ast/transform/PragmaChecker.cpp
    ast/transform/ReduceExistentials.cpp
    ast/transform/RemoveBooleanConstraints.cpp
    ast/transform/RemoveEmptyRelations.cpp
    ast/transform/RemoveRedundantRelations.cpp
    ast/transform/RemoveRedundantSums.cpp
    ast/transform/RemoveRelationCopies.cpp
    ast/transform/ReplaceSingletonVariables.cpp
    ast/transform/ResolveAliases.cpp
    ast/transform/ResolveAnonymousRecordAliases.cpp
    ast/transform/SemanticChecker.cpp
    ast/transform/SimplifyConstantBinaryConstraints.cpp
    ast/transform/SubsumptionQualifier.cpp
    ast/transform/SimplifyAggregateTargetExpression.cpp
    ast/transform/Transformer.cpp
    ast/transform/TypeChecker.cpp
    ast/transform/UniqueAggregationVariables.cpp
    ast/utility/BindingStore.cpp
    ast2ram/utility/SipsMetric.cpp
    ast2ram/utility/SipGraph.cpp
    ast/utility/Utils.cpp
    ast2ram/provenance/ClauseTranslator.cpp
    ast2ram/provenance/ConstraintTranslator.cpp
    ast2ram/provenance/SubproofGenerator.cpp
    ast2ram/provenance/TranslationStrategy.cpp
    ast2ram/provenance/UnitTranslator.cpp
    ast2ram/seminaive/ClauseTranslator.cpp
    ast2ram/seminaive/ConstraintTranslator.cpp
    ast2ram/seminaive/TranslationStrategy.cpp
    ast2ram/seminaive/UnitTranslator.cpp
    ast2ram/seminaive/ValueTranslator.cpp
    ast2ram/utility/Utils.cpp
    ast2ram/utility/TranslatorContext.cpp
    ast2ram/utility/ValueIndex.cpp
    interpreter/Engine.cpp
    interpreter/Generator.cpp
    interpreter/BrieIndex.cpp
    interpreter/BTreeIndex.cpp
    interpreter/BTreeDeleteIndex.cpp
    interpreter/EqrelIndex.cpp
    interpreter/ProvenanceIndex.cpp
    parser/ParserDriver.cpp
    parser/ParserUtils.cpp
    parser/SrcLocation.cpp
    parser/VirtualFileSystem.cpp
    ram/Node.cpp
    ram/TranslationUnit.cpp
    ram/analysis/Complexity.cpp
    ram/analysis/Index.cpp
    ram/analysis/Level.cpp
    ram/analysis/Relation.cpp
    ram/transform/IfExistsConversion.cpp
    ram/transform/CollapseFilters.cpp
    ram/transform/EliminateDuplicates.cpp
    ram/transform/ExpandFilter.cpp
    ram/transform/HoistAggregate.cpp
    ram/transform/HoistConditions.cpp
    ram/transform/IfConversion.cpp
    ram/transform/MakeIndex.cpp
    ram/transform/Parallel.cpp
    ram/transform/ReorderConditions.cpp
    ram/transform/ReorderFilterBreak.cpp
    ram/transform/Transformer.cpp
    ram/transform/TupleId.cpp
    ram/utility/NodeMapper.cpp
    reports/ErrorReport.cpp
    reports/DebugReport.cpp
    synthesiser/Synthesiser.cpp
    synthesiser/Relation.cpp
    synthesiser/Utils.cpp
    synthesiser/GenDb.cpp
)

# --------------------------------------------------
# Flex/Bison
# --------------------------------------------------
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/parser")

flex_target(scanner parser/scanner.ll ${CMAKE_CURRENT_BINARY_DIR}/parser/scanner.cc
  COMPILE_FLAGS "${SCANNER_COMPILE_FLAGS} -d")

bison_target(parser parser/parser.yy ${CMAKE_CURRENT_BINARY_DIR}/parser/parser.cc
             COMPILE_FLAGS "-Wall -Wno-error=deprecated -Wno-error=other -v -d")
add_flex_bison_dependency(scanner parser)


if (MSVC)
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser/scanner.cc PROPERTIES
             COMPILE_FLAGS "/wd4005 /wd4996")
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser/parser.cc PROPERTIES
             COMPILE_FLAGS "/wd4005 /wd26819")
elseif (EMSCRIPTEN)
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser/parser.cc PROPERTIES
             COMPILE_FLAGS "-Wno-error=unused-but-set-variable")
else ()
  # OSX compiler doesn't recognise `(void)var;` ideom
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser/scanner.cc PROPERTIES
             COMPILE_FLAGS "-Wno-error=unused-parameter")
  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/parser/parser.cc PROPERTIES
             COMPILE_FLAGS "-Wno-error=unused-but-set-variable")
endif ()

# --------------------------------------------------
# Souffle library
# --------------------------------------------------
add_library(libsouffle STATIC
            ${SOUFFLE_SOURCES}
            ${FLEX_scanner_OUTPUTS}
            ${BISON_parser_OUTPUTS}
            )

# Make most of the attributes public.  Note that that's strictly not "correct" but
# this library is not going to be installed and it makes it easier to build
# the other targets in this project.  It encapsulates things nicely.
target_include_directories(libsouffle
                           PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include"
                                  "${CMAKE_CURRENT_SOURCE_DIR}"
                                  "${CMAKE_CURRENT_BINARY_DIR}"
                           )

# install souffle directory
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/souffle DESTINATION include)

add_library(compiled STATIC dummy.cpp)

target_include_directories(compiled PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

# Set C++ standard to C++17
target_compile_features(libsouffle PUBLIC cxx_std_17)
target_compile_features(compiled PUBLIC cxx_std_17)

set_target_properties(libsouffle PROPERTIES CXX_EXTENSIONS OFF)
set_target_properties(libsouffle PROPERTIES POSITION_INDEPENDENT_CODE ON)

set_target_properties(compiled PROPERTIES CXX_EXTENSIONS OFF)
set_target_properties(compiled PROPERTIES POSITION_INDEPENDENT_CODE ON)

if (NOT MSVC)
  target_compile_options(libsouffle PUBLIC -Wall -Wextra -fwrapv)
else ()
  target_compile_options(libsouffle PUBLIC /W3)
endif ()

target_compile_options(compiled PUBLIC "")

if (Threads_FOUND)
  target_link_libraries(libsouffle PUBLIC Threads::Threads)
  target_link_libraries(compiled PUBLIC Threads::Threads)
endif ()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
    target_link_libraries(libsouffle PUBLIC stdc++fs)
    target_link_libraries(compiled PUBLIC stdc++fs)
  endif ()
endif ()


if(SOUFFLE_CODE_COVERAGE AND CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_link_libraries(libsouffle PUBLIC coverage_config)
endif ()


target_link_libraries(libsouffle PUBLIC "${CMAKE_DL_LIBS}")
target_link_libraries(compiled PUBLIC "${CMAKE_DL_LIBS}")


if (SOUFFLE_DOMAIN_64BIT)
    target_compile_definitions(libsouffle PUBLIC RAM_DOMAIN_SIZE=64)
    target_compile_definitions(compiled PUBLIC RAM_DOMAIN_SIZE=64)
endif()

if (SOUFFLE_USE_LIBFFI)
if (libffi_FOUND)
  target_link_libraries(libsouffle PUBLIC libffi)
else ()
  target_link_libraries(libsouffle PUBLIC LibFFI::LibFFI)
endif ()
endif ()

if (OPENMP_FOUND)
    target_link_libraries(libsouffle PUBLIC OpenMP::OpenMP_CXX)
    target_link_libraries(compiled PUBLIC OpenMP::OpenMP_CXX)
endif()

if (SOUFFLE_CUSTOM_GETOPTLONG)
    target_compile_definitions(libsouffle
                               PUBLIC USE_CUSTOM_GETOPTLONG)
    target_compile_definitions(compiled
                               PUBLIC USE_CUSTOM_GETOPTLONG)
endif()

if (SOUFFLE_USE_CURSES)
    target_compile_definitions(libsouffle PUBLIC USE_NCURSES)
    target_compile_definitions(compiled PUBLIC USE_NCURSES)
    target_link_libraries(libsouffle PUBLIC Curses::NCurses)
    target_link_libraries(compiled PUBLIC Curses::NCurses)
endif()

if (SOUFFLE_USE_ZLIB)
    target_compile_definitions(libsouffle PUBLIC USE_LIBZ)
    target_compile_definitions(compiled PUBLIC USE_LIBZ)
    target_link_libraries(libsouffle PUBLIC ZLIB::ZLIB)
    target_link_libraries(compiled PUBLIC ZLIB::ZLIB)
endif()

if (SOUFFLE_USE_SQLITE)
    target_compile_definitions(libsouffle PUBLIC USE_SQLITE)
    target_compile_definitions(compiled PUBLIC USE_SQLITE)
    target_link_libraries(libsouffle PUBLIC SQLite::SQLite3)
    target_link_libraries(compiled PUBLIC SQLite::SQLite3)
    target_include_directories(compiled PUBLIC ${SQLite3_INCLUDE_DIRS})
endif()

if (SOUFFLE_USE_LIBFFI)
    target_compile_definitions(libsouffle
      PUBLIC USE_LIBFFI)
endif()

# The target names "souffle" for the library and "souffle" for the binary
# clash in cmake.  I could just rename the library (since it's private)
# but to keep things "familiar", I renamed the target to "libsouffle"
# but have to adjust the output name, otherwise the library would be
# called "liblibsouffle"
set_target_properties(libsouffle PROPERTIES OUTPUT_NAME "souffle")

# --------------------------------------------------
# Souffle binary
# --------------------------------------------------
add_executable(souffle
               souffle.cpp)
target_link_libraries(souffle libsouffle)
install(TARGETS souffle DESTINATION bin)

if (EMSCRIPTEN)
target_link_libraries(souffle -sMODULARIZE=1
                      -s'EXPORTED_RUNTIME_METHODS=["FS"]' -sEXPORT_NAME="SOUFFLE")
endif()

# Copy the dlls in the same directory as Souffle so that they will

=== src/tests/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

souffle_add_binary_test(binary_relation_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(brie_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(btree_multiset_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(btree_set_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(compiled_tuple_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(disjoint_set_property_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(eqrel_datastructure_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(flyweight_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(graph_utils_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(parallel_utils_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(profile_util_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(record_table_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(symbol_table_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(table_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(util_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(visitor_test src SOUFFLE_HEADERS_ONLY)
souffle_add_binary_test(getopt_long_test src SOUFFLE_HEADERS_ONLY)

=== tests/evaluation/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(POSITIVE_TEST NAME)
    souffle_positive_test(${NAME} evaluation ${ARGN})
endfunction()

positive_test(access1)
positive_test(access2)
positive_test(access3)
positive_test(adt-binary-constraint)
positive_test(adt-enum)
positive_test(aggregates)
positive_test(aggregates2)
positive_test(aggregates3)
positive_test(aggregates4)
positive_test(aggregates5)
positive_test(aggregates6)
positive_test(aggregates_complex)
positive_test(aggregates_nested)
positive_test(aggregates_non_materialised)
positive_test(aggregates7)
positive_test(aggregate_witnesses)
positive_test(aliases DEBUG_REPORT)
positive_test(arithm)
positive_test(average)
positive_test(bad_regex)
positive_test(binop)
positive_test(cat)
positive_test(choice_advisor)
positive_test(choice_total_order)
positive_test(choice_highest_mark)
positive_test(choice_colourable)
positive_test(comparator_indirect)
positive_test(comp-override1)
positive_test(comp-override2)
positive_test(comp-override3)
positive_test(components1)
positive_test(components2)
positive_test(components3)
positive_test(components)
positive_test(components_generic)
positive_test(contains)
positive_test(count)
positive_test(count_sccs1)
positive_test(counter)
positive_test(cprog1)
positive_test(cprog2)
positive_test(cprog3)
positive_test(cprog4)
positive_test(cprog5)
positive_test(cproject)
positive_test(eqrel_inc)
positive_test(eqrel_mod)
positive_test(eqrel_reachable)
positive_test(empty_relations)
positive_test(empty_relations2)
positive_test(existential)
positive_test(facts)
positive_test(facts2)
positive_test(float_equality)
positive_test(float_operations)
positive_test(functor_arity)
positive_test(grammar)
positive_test(hex)
positive_test(independent_body1)
if (NOT MSVC)
  # the semantics checker does not produce a deterministic warning
  # message location "variable occurs only once" in complex rules.
positive_test(independent_body2)
endif ()
positive_test(index)
positive_test(indexed_inequalities)
positive_test(indirect_negation)
positive_test(inline_functors)
positive_test(inline_negation1)
positive_test(inline_negation2)
positive_test(inline_nqueens)
positive_test(inline_records)
positive_test(inline_underscore)
positive_test(inline_unification)
positive_test(list)
positive_test(magic_2sat COMPILED_SPLITTED)
positive_test(magic_aggregates COMPILED_SPLITTED)
positive_test(magic_bindings)
positive_test(magic_centroids)
positive_test(magic_circuit_sat)
positive_test(magic_components)
positive_test(magic_cprog1)
positive_test(magic_dfa)
positive_test(magic_dominance)
positive_test(magic_factoring)
positive_test(magic_goal)
positive_test(magic_infbinding)
positive_test(magic_lrg_attr_id)
positive_test(magic_movies)
positive_test(magic_names1)
positive_test(magic_neglabel)
positive_test(magic_negignored)
if (NOT (MSVC AND (CMAKE_BUILD_TYPE MATCHES Debug)))
  # When compiled in Debug with Visual Studio with the default stack size of 1MB,
  # the interpreter fails with a stack overflow in Engine::execute().
  # The cause is the number of lambda functions that are allocated as locals on the stack.
  # The stack frame of Engine::execute is close to 30KB.
  # The 1MB stack will overflow at depth ~34 of Engine::execute().
positive_test(magic_nqueens)
endif ()
positive_test(magic_perfect_numbers)
positive_test(magic_posignored)
positive_test(magic_poslabel)
positive_test(magic_records4)
positive_test(magic_samegen)
positive_test(magic_strategies)
positive_test(magic_string_substr COMPILED_SPLITTED)
positive_test(magic_turing1)
positive_test(match2)
positive_test(match3)
positive_test(match4)
positive_test(match5)
positive_test(match COMPILED_SPLITTED)
# TODO (see issue #298) positive_test(math)
positive_test(max)
positive_test(minmax)
positive_test(minmaxnum)
positive_test(mrtc)
positive_test(mul)
positive_test(multiple_heads)
positive_test(multiple_inequalities)
positive_test(mutrecursion)
positive_test(neg1)
positive_test(neg2)
positive_test(neg3)
positive_test(neg4)
positive_test(neg5)
positive_test(neg6)
positive_test(number_constants)
positive_test(numeric_binary_constraint_op)
positive_test(numeric_conversions)
positive_test(ordinals)
positive_test(plus)
positive_test(range)
positive_test(rangeop)
positive_test(rec_lists2)
positive_test(rec_lists)
positive_test(rec_underscore)
positive_test(recursion)
positive_test(relop)
positive_test(rmut2)
positive_test(rmut)
positive_test(set_ops)
positive_test(set_ops_output)
positive_test(simple)
positive_test(singleton)
positive_test(subsumption)
positive_test(subtype2)
positive_test(subtype)
positive_test(sum-aggregate)
positive_test(sum-aggregate2)
positive_test(symbol_operations)
positive_test(term)
positive_test(unpacking)
positive_test(unsigned_operations)
positive_test(unused_constraints)
positive_test(x9)
positive_test(issue2160)

add_subdirectory(issue2508)
souffle_positive_functor_test(issue2508 CATEGORY evaluation)
positive_test(issue2532)

=== tests/example/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(POSITIVE_TEST NAME)
    souffle_positive_test(${NAME} example ${ARGN})
endfunction()

function(NEGATIVE_TEST NAME)
    souffle_negative_test(${NAME} example)
endfunction()

positive_test(2sat)
positive_test(access-policy)
positive_test(ackermann)
positive_test(amicable)
positive_test(andersen)
positive_test(array)
positive_test(bigrams)
positive_test(catalan)
positive_test(cba_expr_value)
positive_test(cellular_automata)
positive_test(centroids)
positive_test(circuit_eval)
positive_test(circuit_records)
positive_test(circuit_sat)
positive_test(clique)
positive_test(cliquer)
positive_test(comp-parametrized-inherit)
positive_test(comp-parametrized-multilvl)
positive_test(comp-parametrized)
positive_test(convex_hull)
positive_test(counter)
positive_test(degree)
positive_test(dfa)
positive_test(dfa_live_vars)
positive_test(dfa_min)
positive_test(dfa_parse)
positive_test(dfa_summary_function)
positive_test(disconnected)
positive_test(dnf)
positive_test(dominance)
positive_test(double_tree)
positive_test(earley)
positive_test(edit_distance)
positive_test(equal)
positive_test(euclid)
positive_test(factorial)
positive_test(factoring)
positive_test(family)
positive_test(fib)
positive_test(fib1)
positive_test(flights)
positive_test(flights2)
positive_test(floydwarshall)
positive_test(fractional_knapsack)
positive_test(func)
positive_test(game2)
positive_test(grad)
positive_test(graph)
positive_test(grid)
positive_test(highest_degree)
positive_test(hmmer)
positive_test(independent_body3)
positive_test(inline_nats)
positive_test(input_output)
positive_test(java-pointsto)
positive_test(josephus)
positive_test(k-permutations)
positive_test(linksum)
positive_test(longest_path)
positive_test(lubm)
souffle_positive_multi_test(TEST_NAME lucas CATEGORY example FACTS_DIR_NAMES fibonacci lucas mersenne pell)
positive_test(magic_access-policy)
positive_test(magic_prime2)
positive_test(magic_pointsto)
positive_test(metro)
positive_test(minesweeper)
positive_test(minimum_spanning_tree)
positive_test(minpath1)
positive_test(minpath2)
positive_test(minpath3)
positive_test(mmult)
positive_test(movies)
souffle_positive_multi_test(TEST_NAME nfsa2fsa CATEGORY example FACTS_DIR_NAMES ex1 ex2)
positive_test(not_match)
positive_test(nqueens)
positive_test(orbits1)
positive_test(orbits)
positive_test(palindrome)
positive_test(paths)
positive_test(peano_arithmetic)
positive_test(perfect_numbers)
positive_test(planar)
positive_test(po1)
positive_test(po2)
positive_test(po3)
positive_test(po4)
positive_test(po5)
positive_test(pointsto)
positive_test(prime2)
positive_test(prime)
positive_test(profile_default)
positive_test(profile_json)
positive_test(puzzle)
positive_test(ranpo)
positive_test(recipes)
positive_test(rsg)
positive_test(rewrite)
positive_test(sequences)
positive_test(ship)
positive_test(shortest_edges)
positive_test(shortest_path)
positive_test(shortest_path2)
positive_test(small)
positive_test(sort)
positive_test(speed)
positive_test(strategies)
positive_test(tak)
positive_test(tc)
positive_test(tic-tac-toe)
positive_test(topological_ordering)
positive_test(traffic)
positive_test(trains)
positive_test(trans)
positive_test(tree)
positive_test(triangle)
positive_test(turing1)
positive_test(weighted_distances)

=== tests/interface/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

# Make sure that the functor library is built
add_subdirectory(aggregates)
add_subdirectory(functors)
add_subdirectory(graph_coloring)
add_subdirectory(pathseq)
add_subdirectory(lattice1)
add_subdirectory(lattice2)
add_subdirectory(lattice3)

function(SOUFFLE_RUN_CPP_TEST)
    cmake_parse_arguments(
        PARAM
        ""
        "PARAM_TEST_NAME;QUALIFIED_TEST_NAME;INPUT_DIR;OUTPUT_DIR;FIXTURE_NAME;TEST_LABELS;FACTS_DIR"
        ""
        ${ARGV}
    )

  set(ADDITIONNAL_FLAGS)

  if (OPENMP_FOUND)
    list(APPEND ADDITIONNAL_FLAGS ${OpenMP_CXX_FLAGS})
  endif()

  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
      list(APPEND ADDITIONNAL_FLAGS "-lstdc++fs")
    endif ()
  endif()

  if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    set(OUTNAME ${TEST_NAME})
    set(OUT_OPTION "-o" "${TEST_NAME}")
  elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    set(OUTNAME "${TEST_NAME}.exe")
    set(OUT_OPTION "/Fe:${TEST_NAME}")
    list(APPEND ADDITIONNAL_FLAGS "/Zc:preprocessor")
    list(APPEND ADDITIONNAL_FLAGS "/permissive-")
    list(APPEND ADDITIONNAL_FLAGS "/EHsc")
    list(APPEND ADDITIONNAL_FLAGS "/D_CRT_SECURE_NO_WARNINGS")
    list(APPEND ADDITIONNAL_FLAGS "/nologo")
  endif ()

  # compilation
  add_test(NAME ${PARAM_QUALIFIED_TEST_NAME}_compile_cpp
    COMMAND
      ${CMAKE_CXX_COMPILER}
      ${CMAKE_CXX17_STANDARD_COMPILE_OPTION}
      ${OUT_OPTION}
      -D__EMBEDDED_SOUFFLE__
      "-I${CMAKE_SOURCE_DIR}/src/include"
      "${TEST_NAME}.cpp"
      "${PARAM_INPUT_DIR}/driver.cpp"
      ${ADDITIONNAL_FLAGS})

  set_tests_properties(${PARAM_QUALIFIED_TEST_NAME}_compile_cpp PROPERTIES
    WORKING_DIRECTORY "${PARAM_OUTPUT_DIR}"
    LABELS "${PARAM_TEST_LABELS}"
    FIXTURES_SETUP ${PARAM_FIXTURE_NAME}_compile_cpp
    FIXTURES_REQUIRED ${PARAM_FIXTURE_NAME}_run_souffle)

  # execution
  add_test(NAME ${PARAM_QUALIFIED_TEST_NAME}_run_cpp
    COMMAND
    ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/cmake/redirect.py
      --out "${TEST_NAME}.out"
      --err "${TEST_NAME}.err"
      "${OUTNAME}" "${FACTS_DIR}")

  set_tests_properties(${PARAM_QUALIFIED_TEST_NAME}_run_cpp PROPERTIES
    WORKING_DIRECTORY "${PARAM_OUTPUT_DIR}"
    LABELS "${PARAM_TEST_LABELS}"
    FIXTURES_SETUP ${PARAM_FIXTURE_NAME}_run_cpp
    FIXTURES_REQUIRED ${PARAM_FIXTURE_NAME}_compile_cpp
    )
endfunction()

function(SOUFFLE_RUN_CPP_TEST_HELPER)
    # PARAM_TEST_NAME - the name of the test, the short directory name under tests/<category>/<test_name>
    cmake_parse_arguments(
        PARAM
        "COMPARE_STDOUT"
        "TEST_NAME" #Single valued options
        ""
        ${ARGV}
    )

    set(INPUT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${PARAM_TEST_NAME}")
    set(FACTS_DIR "${INPUT_DIR}/facts")
    set(OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/${PARAM_TEST_NAME}")
    # Give the test a name which has good info about it when running
    # People can then search for the test by the name, or the labels we create
    set(QUALIFIED_TEST_NAME interface/${PARAM_TEST_NAME})
    set(FIXTURE_NAME ${QUALIFIED_TEST_NAME}_fixture)
    set(TEST_LABELS "positive;integration")

    set(PP_FLAGS)
    if (MSVC)
      list(APPEND PP_FLAGS "--preprocessor" "cl -nologo -TC -E")
    endif()


    souffle_setup_integration_test_dir(TEST_NAME ${PARAM_TEST_NAME}
                                       QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                       DATA_CHECK_DIR ${INPUT_DIR}
                                       OUTPUT_DIR ${OUTPUT_DIR}
                                       EXTRA_DATA ${EXTRA}
                                       FIXTURE_NAME ${FIXTURE_NAME}
                                       TEST_LABELS ${TEST_LABELS})

    souffle_run_integration_test(TEST_NAME ${PARAM_TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 INPUT_DIR ${INPUT_DIR}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 FIXTURE_NAME ${FIXTURE_NAME}
                                 TEST_LABELS "${TEST_LABELS}"
                                 SOUFFLE_PARAMS "-g" "${OUTPUT_DIR}/${TEST_NAME}.cpp" ${PP_FLAGS})

    souffle_run_cpp_test(TEST_NAME ${PARAM_TEST_NAME}
                         QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                         INPUT_DIR ${INPUT_DIR}
                         OUTPUT_DIR ${OUTPUT_DIR}
                         FIXTURE_NAME ${FIXTURE_NAME}
                         FACTS_DIR "${FACTS_DIR}"
                         TEST_LABELS ${TEST_LABELS})

    souffle_compare_std_outputs(TEST_NAME ${PARAM_TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 EXTRA_DATA ${EXTRA}
                                 RUN_AFTER_FIXTURE ${FIXTURE_NAME}_run_cpp
                                 TEST_LABELS ${TEST_LABELS})

    souffle_compare_csv(QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                        INPUT_DIR ${INPUT_DIR}
                        OUTPUT_DIR ${OUTPUT_DIR}
                        RUN_AFTER_FIXTURE ${FIXTURE_NAME}_run_cpp
                        NEGATIVE ${PARAM_NEGATIVE}
                        TEST_LABELS ${TEST_LABELS})

endfunction()

# cpp test which will compile Souffle programs externally
function(SOUFFLE_POSITIVE_CPP_TEST TEST_NAME)
    souffle_run_cpp_test_helper(TEST_NAME ${TEST_NAME} ${ARGN})
endfunction()

souffle_positive_functor_test(aggregates CATEGORY interface)
souffle_positive_functor_test(functors CATEGORY interface)
souffle_positive_functor_test(pathseq CATEGORY interface)
souffle_positive_functor_test(graph_coloring CATEGORY interface)
souffle_positive_functor_test(lattice1 CATEGORY interface)
souffle_positive_functor_test(lattice2 CATEGORY interface)
souffle_positive_functor_test(lattice3 CATEGORY interface)
souffle_positive_cpp_test(contain_insert)
souffle_positive_cpp_test(get_symboltabletype)
souffle_positive_cpp_test(insert_for)
souffle_positive_cpp_test(insert_print)
souffle_positive_cpp_test(load_print)
souffle_positive_cpp_test(signal_error)
souffle_positive_cpp_test(tuple_insertion_diff_element_type)
souffle_positive_cpp_test(tuple_insertion_diff_relation)

# The following test fails because we use -g (instead -o)
# TODO: (This neeads to be investigated)
# souffle_positive_cpp_test(repeat_analysis)

=== tests/libsouffle_interface/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2022 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

souffle_add_binary_test(vfs_overlay_test libsouffle)
souffle_add_binary_test(souffle_doc_test libsouffle)

=== tests/link/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(SOUFFLE_LINK_TEST)
    cmake_parse_arguments(
        PARAM
        "NEGATIVE"
        "TEST_NAME"
        "DATALOG_FILES"
        ${ARGV}
    )

    set(INPUT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${PARAM_TEST_NAME}")
    set(FACTS_DIR "${INPUT_DIR}/facts")

    if (PARAM_NEGATIVE)
        set(TEST_SUFFIX "_negative")
        set (NAMESPACE_FLAG "")
    else ()
        set(NAMESPACE_FLAG "--namespace")
    endif()

    set(OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/${PARAM_TEST_NAME}${TEST_SUFFIX}")


    ADD_TEST(NAME "${PARAM_TEST_NAME}${TEST_SUFFIX}"
        COMMAND
        ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/cmake/redirect.py
        --out ${PARAM_TEST_NAME}.out
        --err ${PARAM_TEST_NAME}.err
        ${Python3_EXECUTABLE}
        ${INPUT_DIR}/test.py
        --input_dir ${INPUT_DIR}
        --output_dir ${OUTPUT_DIR}
        --cxx ${CMAKE_CXX_COMPILER}
        --souffle $<TARGET_FILE:souffle>
        --driver driver.cpp
        --include "${CMAKE_SOURCE_DIR}/src/include"
        ${NAMESPACE_FLAG}
        ${PARAM_DATALOG_FILES}
        COMMAND_EXPAND_LISTS
        WORKING_DIRECTORY ${INPUT_DIR}
    )

    if (PARAM_NEGATIVE)
        set_tests_properties("${PARAM_TEST_NAME}${TEST_SUFFIX}" PROPERTIES WILL_FAIL TRUE)
    endif()

endfunction()

if (UNIX)
    souffle_link_test(TEST_NAME link2 DATALOG_FILES insert_for1.dl insert_for2.dl)
    souffle_link_test(NEGATIVE TEST_NAME link2 DATALOG_FILES insert_for1.dl insert_for2.dl)
endif(UNIX)

=== tests/profile/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(SOUFFLE_RUN_PROF_TEST)
    cmake_parse_arguments(
        PARAM
        ""
        "PARAM_TEST_NAME;QUALIFIED_TEST_NAME;INPUT_DIR;OUTPUT_DIR;FIXTURE_NAME;TEST_LABELS;FACTS_DIR"
        ""
        ${ARGV}
    )
    # Run souffle (through the shell, so we can easily redirect)


    SET(CMD_LIST "rel;rel R2;rul;rul C2.1;rul id N2.1;graph R2 copy_t;graph C2.1 tot_t;graph ver C2.1 tuples;top;help")
    foreach(CMD IN LISTS CMD_LIST)
       SET(CMD_NAME "${PARAM_QUALIFIED_TEST_NAME}_run_prof_${CMD}")

       string(REPLACE " " "_" CMD_NAME ${CMD_NAME})

       SET(CMD_EXEC "set -e$<SEMICOLON> '$<TARGET_FILE:souffleprof>' '${OUTPUT_DIR}/${TEST_NAME}.prof' -c '${CMD}' >'${CMD}.out'")

       add_test(NAME "${CMD_NAME}" COMMAND sh -c "${CMD_EXEC}")

       set_tests_properties("${CMD_NAME}" PROPERTIES
                         WORKING_DIRECTORY "${PARAM_OUTPUT_DIR}"
                         LABELS "${PARAM_TEST_LABELS}"
                         FIXTURES_SETUP "${CMD_NAME}"
                         FIXTURES_REQUIRED ${PARAM_FIXTURE_NAME}_run_souffle
                        )

       SET(CMD_NAME_CMP "${PARAM_QUALIFIED_TEST_NAME}_cmp_prof_${CMD}")

       string(REPLACE " " "_" CMD_NAME_CMP ${CMD_NAME_CMP})

       SET(CMD_EXEC "[[ `cat '${CMD}.out'|wc -l` == `cat '${INPUT_DIR}/out/${CMD}.out'|wc -l` ]]")

       add_test(NAME "${CMD_NAME_CMP}" COMMAND bash -c "${CMD_EXEC}")

       set_tests_properties("${CMD_NAME_CMP}" PROPERTIES
                         WORKING_DIRECTORY "${PARAM_OUTPUT_DIR}"
                         LABELS "${PARAM_TEST_LABELS}"
                         FIXTURES_SETUP "${CMD_NAME_CMP}"
                         FIXTURES_REQUIRED ${CMD_NAME}
                        )

    endforeach()
endfunction()



function(SOUFFLE_RUN_PROF_TEST_HELPER)
    # PARAM_TEST_NAME - the name of the test, the short directory name under tests/<category>/<test_name>
    cmake_parse_arguments(
        PARAM
        "COMPARE_STDOUT"
        "TEST_NAME" #Single valued options
        ""
        ${ARGV}
    )

    set(INPUT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${PARAM_TEST_NAME}")
    set(FACTS_DIR "${INPUT_DIR}/facts")
    set(OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/${PARAM_TEST_NAME}")
    # Give the test a name which has good info about it when running
    # People can then search for the test by the name, or the labels we create
    set(QUALIFIED_TEST_NAME profile/${PARAM_TEST_NAME})
    set(FIXTURE_NAME ${QUALIFIED_TEST_NAME}_fixture)
    set(TEST_LABELS "positive;integration")

    souffle_setup_integration_test_dir(TEST_NAME ${PARAM_TEST_NAME}
                                       QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                       DATA_CHECK_DIR ${INPUT_DIR}
                                       OUTPUT_DIR ${OUTPUT_DIR}
                                       EXTRA_DATA ${EXTRA}
                                       FIXTURE_NAME ${FIXTURE_NAME}
                                       TEST_LABELS ${TEST_LABELS})

    souffle_run_integration_test(TEST_NAME ${PARAM_TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 INPUT_DIR ${INPUT_DIR}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 FIXTURE_NAME ${FIXTURE_NAME}
                                 TEST_LABELS "${TEST_LABELS}"
                                 SOUFFLE_PARAMS "-p" "${OUTPUT_DIR}/${TEST_NAME}.prof")

    souffle_run_prof_test(TEST_NAME ${PARAM_TEST_NAME}
                         QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                         INPUT_DIR ${INPUT_DIR}
                         OUTPUT_DIR ${OUTPUT_DIR}
                         FIXTURE_NAME ${FIXTURE_NAME}
                         FACTS_DIR "${FACTS_DIR}"
                         TEST_LABELS ${TEST_LABELS})

    souffle_compare_std_outputs(TEST_NAME ${PARAM_TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 EXTRA_DATA ${EXTRA}
                                 RUN_AFTER_FIXTURE ${FIXTURE_NAME}_run_prof
                                 TEST_LABELS ${TEST_LABELS})

    souffle_compare_csv(QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                        INPUT_DIR ${INPUT_DIR}
                        OUTPUT_DIR ${OUTPUT_DIR}
                        RUN_AFTER_FIXTURE ${FIXTURE_NAME}_run_prof
                        NEGATIVE ${PARAM_NEGATIVE}
                        TEST_LABELS ${TEST_LABELS})

endfunction()

# prof test which will compile Souffle programs externally
function(SOUFFLE_POSITIVE_PROF_TEST TEST_NAME)
    souffle_run_prof_test_helper(TEST_NAME ${TEST_NAME} ${ARGN})
endfunction()

if (NOT MSVC)
if (NOT (APPLE AND ("${CMAKE_HOST_SYSTEM_PROCESSOR}" STREQUAL "arm64")))
souffle_positive_prof_test(lrg_attr_id)
souffle_positive_prof_test(recursive)
endif()
endif ()

=== tests/scheduler/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(SOUFFLE_ADD_SCHEDULER_TEST TEST_NAME)
    set(INPUT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${TEST_NAME}")
    set(FACTS_DIR "${INPUT_DIR}/facts")
    set(OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}")
    set(TEST_LABELS "scheduler;positive;integration")

    # Setup test dir
    set(QUALIFIED_TEST_NAME scheduler/${TEST_NAME})
    set(FIXTURE_NAME ${QUALIFIED_TEST_NAME}_fixture)
    souffle_setup_integration_test_dir(TEST_NAME ${TEST_NAME}
                                       QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                       DATA_CHECK_DIR ${INPUT_DIR}
                                       OUTPUT_DIR ${OUTPUT_DIR}
                                       FIXTURE_NAME ${FIXTURE_NAME}
                                       TEST_LABELS ${TEST_LABELS})

    set(QUALIFIED_TEST_NAME scheduler/${TEST_NAME}_stats_collection)
    # Run stats collection
    set(SOUFFLE_PARAMS "-p" "${OUTPUT_DIR}/${TEST_NAME}.prof" "--emit-statistics")
    add_test(NAME ${QUALIFIED_TEST_NAME}
      COMMAND
      ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/cmake/redirect.py
        --out ${TEST_NAME}.out
        --err ${TEST_NAME}.err
        ${STDIN_ARGS}
        $<TARGET_FILE:souffle>
        ${SOUFFLE_PARAMS}
        "${INPUT_DIR}/${TEST_NAME}.dl"
      COMMAND_EXPAND_LISTS)

    set_tests_properties(${QUALIFIED_TEST_NAME} PROPERTIES
      WORKING_DIRECTORY "${OUTPUT_DIR}"
      LABELS "${TEST_LABELS}"
      FIXTURES_SETUP ${FIXTURE_NAME}_stats_collection
      FIXTURES_REQUIRED ${FIXTURE_NAME}_setup)

    # Check output
    souffle_compare_std_outputs(TEST_NAME ${TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 RUN_AFTER_FIXTURE ${FIXTURE_NAME}_stats_collection
                                 TEST_LABELS ${TEST_LABELS})

    souffle_compare_csv(QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                        INPUT_DIR ${INPUT_DIR}
                        OUTPUT_DIR ${OUTPUT_DIR}
                        RUN_AFTER_FIXTURE ${FIXTURE_NAME}_stats_collection
                        NEGATIVE ${PARAM_NEGATIVE}
                        TEST_LABELS ${TEST_LABELS})

    # Run scheduler
    set(QUALIFIED_TEST_NAME scheduler/${TEST_NAME}_auto_scheduler)
    set(SOUFFLE_PARAMS "--auto-schedule" "${OUTPUT_DIR}/${TEST_NAME}.prof" "-c")
    add_test(NAME ${QUALIFIED_TEST_NAME}
      COMMAND
      ${Python3_EXECUTABLE} ${PROJECT_SOURCE_DIR}/cmake/redirect.py
        --out ${TEST_NAME}.out
        --err ${TEST_NAME}.err
        ${STDIN_ARGS}
        $<TARGET_FILE:souffle>
        ${SOUFFLE_PARAMS}
        "${INPUT_DIR}/${TEST_NAME}.dl"
      COMMAND_EXPAND_LISTS)

    set_tests_properties(${QUALIFIED_TEST_NAME} PROPERTIES
      WORKING_DIRECTORY "${OUTPUT_DIR}"
      LABELS "${TEST_LABELS}"
      FIXTURES_SETUP ${FIXTURE_NAME}_auto_scheduler
      FIXTURES_REQUIRED ${FIXTURE_NAME}_stats_collection)

    # Check output
    souffle_compare_std_outputs(TEST_NAME ${TEST_NAME}
                                 QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                                 OUTPUT_DIR ${OUTPUT_DIR}
                                 RUN_AFTER_FIXTURE ${FIXTURE_NAME}_auto_scheduler
                                 TEST_LABELS ${TEST_LABELS})

    souffle_compare_csv(QUALIFIED_TEST_NAME ${QUALIFIED_TEST_NAME}
                        INPUT_DIR ${INPUT_DIR}
                        OUTPUT_DIR ${OUTPUT_DIR}
                        RUN_AFTER_FIXTURE ${FIXTURE_NAME}_auto_scheduler
                        NEGATIVE ${PARAM_NEGATIVE}
                        TEST_LABELS ${TEST_LABELS})
endfunction()

if (NOT MSVC)
    souffle_add_scheduler_test(functionality)
    souffle_add_scheduler_test(eqrel)
endif()

=== tests/semantic/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    add_subdirectory(pragma2)
endif()

add_subdirectory(functor_fact)
add_subdirectory(issue2373)


function(positive_test NAME)
    souffle_positive_test(${NAME} semantic ${ARGN})
endfunction()

function(positive_output_stdout_test NAME)
    souffle_run_test_helper(TEST_NAME ${NAME} CATEGORY semantic OUTPUT_STDOUT ${ARGV})
    souffle_run_test_helper(TEST_NAME ${NAME} CATEGORY semantic OUTPUT_STDOUT ${ARGV} COMPILED)
endfunction()

function(negative_test NAME)
    souffle_negative_test(${NAME} semantic)
endfunction()

negative_test(adt_invalid_arity)
negative_test(adt_invalid_branch)
negative_test(agg_checks)
negative_test(agg_checks2)
positive_test(agg_checks3)
positive_test(aggregate1)
positive_test(aggregate2)
positive_test(aggregate3)
positive_test(aggregate4)
positive_test(aggregate5)
positive_test(aggregate6)
positive_test(agg_nested)
positive_test(alias)
negative_test(attrib_dupl)
positive_test(bin1)
positive_test(bin COMPILED_SPLITTED)
positive_test(binhex)
positive_test(bitwise)
positive_test(bool)
negative_test(choice)
negative_test(comp_clauses)
negative_test(comp_infinite_recursion)
positive_test(comp_inner_types)
negative_test(comp_name_resolution)
negative_test(comp_nonexistent_type)
negative_test(comp_override)
negative_test(comp_params_inheritance)
negative_test(comp_relation)
negative_test(comp_types)
positive_test(comp_types2)
positive_test(comp_opt)
negative_test(counter2)
positive_test(counter)
negative_test(disjoint_names)
# TODO (see issue #231) negative_test(divide_by_zero)
positive_test(duplicates)
positive_test(eqrel_tests COMPILED_SPLITTED)
positive_test(eqrel_tests2)
positive_test(eqrel_tests3)
positive_test(eqrel_tests4)
positive_test(equivalent)
negative_test(execution_plan)
positive_test(extended_subtypes)
negative_test(extended_subtypes2)
negative_test(extended_subtypes3)
negative_test(fact_arity)
negative_test(fact_cat)
negative_test(fact_ctr)
negative_test(fact_empty)
negative_test(fact_number2)
negative_test(fact_number)
negative_test(fact_plus)
negative_test(fact_variable)
positive_test(func_in_rec)
positive_test(hex1)
positive_test(hex)
positive_test(identity_functor)
positive_test(identity_functor_inf_loop)
negative_test(inline_cycle1)
positive_test(inline_cycle2)
negative_test(inline_exclude)
negative_test(inline_ungrounded)
negative_test(inline_negation)
negative_test(inline_output)
positive_test(inline_segfault)
positive_test(interval)
positive_test(ipv4)
positive_test(ipv4_1)
souffle_run_test(TEST_NAME json CATEGORY semantic EXTRA_DATA json)
souffle_run_test(TEST_NAME jsonfile CATEGORY semantic EXTRA_DATA json)
negative_test(keys)
positive_test(keys1)
positive_test(keys2)
positive_test(leq COMPILED_SPLITTED)
positive_test(limitsize)
negative_test(load2)
negative_test(load3)
negative_test(load4)
if (SOUFFLE_USE_ZLIB)
positive_test(load6)
endif ()
positive_test(load7)
positive_test(load8)
positive_test(load9)
negative_test(load10)
positive_test(load11)
positive_test(load12)
positive_test(load13)
positive_test(load_adt)
positive_test(load_adt2)
positive_test(load_adt3)
positive_test(load_record_delimiter)
positive_test(load_record_large)
positive_test(load_record_large2)
negative_test(load_record_invalid_parenthesis)
positive_test(load_simple_record)
positive_test(load_simple_record2)
positive_test(load_symbol_in_record)
positive_test(logical)
positive_test(lrg_attr_id COMPILED_SPLITTED)
positive_test(lrg_rel_id1)
positive_test(lrg_rel_id2)
positive_test(negative_numbers)
positive_test(not_copy1)
positive_test(not_copy2)
positive_test(not_copy)
negative_test(plan1)
negative_test(plan2)
positive_test(plan3)
positive_test(progmin1)
positive_test(progmin2)
positive_test(range)
negative_test(record_null)
positive_test(records0)
positive_test(records1)
positive_test(records2)
positive_test(records3)
positive_test(records4)
positive_test(records5)
positive_test(records6)
positive_test(records7)
positive_test(records8)
positive_test(records9)
negative_test(recursive_unions)
negative_test(recursive_unions2)
positive_test(rel_copy_cycles)
negative_test(rel_dupl)
positive_test(rel_list)
positive_test(rel_nullary)
negative_test(rel_stratification2)
negative_test(rel_stratification)
negative_test(rel_udef)
positive_test(rqualifiers)
negative_test(rule_arity)
negative_test(rule_grounded)
negative_test(rule_typecompat)
negative_test(rule_undeclared_relation2)
negative_test(rule_undeclared_relation)
if (SOUFFLE_USE_ZLIB)
    souffle_run_test(TEST_NAME store CATEGORY semantic EXTRA_DATA gzip)
endif()
positive_test(store2)
if (SOUFFLE_USE_SQLITE)
    souffle_run_test(TEST_NAME store3 CATEGORY semantic EXTRA_DATA sqlite3)
    souffle_run_test(TEST_NAME store6 CATEGORY semantic EXTRA_DATA sqlite3)
endif()
positive_test(store4)
positive_test(store5)
positive_test(store_adt)
positive_test(store_adt2)
positive_test(store_adt3)
positive_test(store_record_multilevel)
positive_test(store_record_large)
positive_test(store_record_one_level)
positive_test(strconv)
positive_test(string_len)
positive_test(string_minmax)
positive_test(string_substr1 COMPILED_SPLITTED)
positive_test(string_substr COMPILED_SPLITTED)
positive_test(suppress_warnings)
negative_test(subsumption)
positive_test(subsumption_multiple_rules COMPILED_SPLITTED)
positive_test(type_as)
negative_test(type_as2)
negative_test(type_as3)
negative_test(type_dupl)
negative_test(type_system1)
negative_test(type_system2)
negative_test(type_system3)
positive_test(type_system4)
positive_test(type_system5)
negative_test(type_system6)
negative_test(type_system7)
positive_test(type_system8)
positive_test(type_system9)
positive_test(type_system10)
negative_test(type_system11)
negative_test(type_system12)
negative_test(type_system13)
negative_test(type_system14)
negative_test(type_system15)
negative_test(type_system16)
positive_test(type_system_negation)
negative_test(type_system_sum_types)
negative_test(type_system_sum_types2)
positive_test(type_system_records)
negative_test(type_system_records2)
negative_test(type_udef)
positive_test(types_components)
negative_test(undeclared_udfs)
positive_test(underscore2)
positive_test(underscore3)
positive_test(underscore4)
negative_test(underscore)
negative_test(union_types)
negative_test(var_single)
negative_test(witness_check)
positive_test(adt_access)
negative_test(bad_functor_types)
positive_test(choice1)
# positive_test(comparison) TODO See PR #1932
negative_test(disjoint_names2)
positive_test(pragma)
positive_test(pragma1)
if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	# Only test `pragma2` w/ interpreter mode.
	# Reason: Linux tooling becomes violently incontinent when confronted with the
	#         idea of an so w/ non alpha-numeric characters in the name.
	#         See `tests/semantic/pragma2/CMakeLists.txt` for details.
	# souffle_positive_functor_test(pragma2 CATEGORY semantic)
	souffle_run_test_helper(TEST_NAME pragma2 FUNCTORS CATEGORY semantic)
endif()
positive_test(rel_redundant)
positive_test(type_as4)
positive_test(record_alias)
positive_test(record_alias2)
positive_test(adt_alias)
if (FALSE)
# semantics checker of complex rule does not catch this
# "variable only occurs once" issue.
positive_test(complex_rule)
endif ()
positive_test(compose_components)
positive_test(inherit_argument)
positive_test(inherit_argument_override)
positive_test(inherit_instance)
positive_test(inherit_instance_override)
positive_test(instantiate_from_inherited)
positive_test(instantiate_from_inherited_override)
souffle_positive_functor_test(functor_fact CATEGORY semantic)
positive_test(underscore5)
negative_test(mutually_dependent_aggregate)
positive_test(independent_aggregate)
positive_test(independent_aggregate2)
souffle_positive_functor_test(issue2373 CATEGORY semantic)
negative_test(error_deduce_type)
positive_output_stdout_test(output_stdout)
positive_test(iteration_counter)
positive_test(issue1896)
positive_test(comp_params)
positive_test(issue2416)
positive_test(agg_range)
positive_test(issue2482)

=== tests/syntactic/CMakeLists.txt ===
# Souffle - A Datalog Compiler
# Copyright (c) 2021 The Souffle Developers. All rights reserved
# Licensed under the Universal Permissive License v 1.0 as shown at:
# - https://opensource.org/licenses/UPL
# - <souffle root>/licenses/SOUFFLE-UPL.txt

include(SouffleTests)

function(POSITIVE_TEST NAME)
    souffle_positive_test(${NAME} syntactic ${ARGN})
endfunction()

function(NEGATIVE_TEST NAME)
    souffle_negative_test(${NAME} syntactic)
endfunction()

positive_test(binary COMPILED_SPLITTED)
positive_test(comment)
positive_test(comment2)
if (FALSE)
# Fails because warning/error reporting has incorrect column when the line contains an inline comment.
positive_test(comment3)
endif ()
positive_test(comment_rule)
positive_test(cpp_keywords)
positive_test(duplicates)
positive_test(empty)
negative_test(execution_plan)
negative_test(input)
positive_test(input_directive3 COMPILED_SPLITTED)
positive_test(input_directive4)
negative_test(input_directive_quotes2)
positive_test(input_directive_quotes4)
negative_test(input_directive_quotes)
positive_test(liberal_identifiers)
positive_test(multiple_heads)
positive_test(name_clash)
positive_test(ordered_constraints)
negative_test(output)
positive_test(output_directive1 COMPILED_SPLITTED)
positive_test(output_directive_quotes2)
positive_test(output_directive_quotes3)
negative_test(printsize)
negative_test(printsize_directive2)
negative_test(printsize_directive)
negative_test(qualifiers)
negative_test(qualifiers2)
positive_test(qualifiers3)
negative_test(qualifiers4)
positive_test(relation)
negative_test(rule)
positive_test(string)
negative_test(syntax1)
negative_test(syntax2)
negative_test(syntax3)
negative_test(syntax4)
negative_test(syntax5)
negative_test(syntax6)
negative_test(syntax7)
negative_test(syntax8)
negative_test(syntax9)
negative_test(syntax10)
positive_test(type)
positive_test(union_comp_type)
positive_test(dot_identifiers)
positive_test(input_adt_names1)
positive_test(input_adt_names2)
positive_test(input_directive_rfc4180)
positive_test(equivalent_types_in_negation)
negative_test(issue2408)
if (NOT MSVC)
# does not pass with Visual Studio pre-processor because it preserves all whitespaces
positive_test(whitespaces)
endif ()
souffle_run_test(
  TEST_NAME include_directive1
  CATEGORY syntactic
  NO_PREPROCESSOR
  )
souffle_run_test(
  TEST_NAME include_directive2
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME include_directive3
  CATEGORY syntactic
  NO_PREPROCESSOR
  )
souffle_run_test(
  TEST_NAME include_directive4
  CATEGORY syntactic
  INCLUDE_DIRS q1 q2
  NO_PREPROCESSOR
  )
souffle_run_test(
  TEST_NAME sourceloc1
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME sourceloc2
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME sourceloc3
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME sourceloc4
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME sourceloc5
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME unterminated_comment
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )
souffle_run_test(
  TEST_NAME annotations
  CATEGORY syntactic
  NO_PREPROCESSOR
  POSITIVE
  )
souffle_run_test( TEST_NAME doc_comment CATEGORY syntactic NO_PREPROCESSOR POSITIVE)
souffle_run_test(
  TEST_NAME doc_comment_dangling1
  CATEGORY syntactic
  NO_PREPROCESSOR
  POSITIVE
  )
souffle_run_test(
  TEST_NAME doc_comment_dangling2
  CATEGORY syntactic
  NO_PREPROCESSOR
  POSITIVE
  )
souffle_run_test(
  TEST_NAME doc_comment_dangling3
  CATEGORY syntactic
  NO_PREPROCESSOR
  NEGATIVE
  )

=== debian/changelog ===
souffle (2.5.0) stable; urgency=low
 * Lattice support
 * Doc comments and annotations
 * Relations with arity up to 22 in intepreter
 * Let `to_number` infer the base
 * Misc fixes and refactoring

 -- Quentin Sabah <quentin.sabah@gmail.com> Wed, 12 Mar 2025 20:00:00 +0100

souffle (2.4.1) stable; urgency=low
 * Remove escapes in arch build (XiaowenHu96)
 * fix windows CI (quentin)
 * Fix subsumption (julienhenry)
 * remove -Werror from CMakeLists.txt (ammkrn)
 * Provide way to debug delta relations and expose iteration counter (julienhenry)
 * fix "variable only occurs once" checker (quentin)
 * fix bad source location for END token (quentin)
 * Fix generated code for eqrel when emitting statistics (fangyi-zhou)
 * do not consider debug_delta relations as empty (julienhenry)
 * Fix auto-scheduler profile mismatch (fangyi-zhou)
 * fixes souffleprof and enable build on Windows (quentin)
 * Enabling souffle-lang/souffle GitHub dependency graph with vcpk (#2427) (quentin)
 * fix sqlite reading of empty values (dbueno)
 * symbol concatenation with binary `+` (quentin)

 -- Quentin Sabah <quentin.sabah@gmail.com>  Wed, 11 Oct 2023 11:00:00 +0100

souffle (2.4) stable; urgency=low
 * New option --generate-many to split the generated C++ Code into multiple files (julienhenry)
 * Purge input and intermediate relations (adamjseitz)
 * Emscripten Build (philzook58)
 * Improved parallel load balance in the interpreter (quentin)
 * User defined aggregate (julienhenry)
 * Improved loading of CSV (strRM, bmeck)
 * Configurable warnings (langston-barrett)
 * Performance improvements for regex matching (strRM)
 * Expose main driver interface (quentin)
 * Allow linking against multiple compiled Souffle programs (ruricolist, quentin)
 * Misc fixes and refactoring (adamjseitz, ruricolist, quentin, b-scholz, mingodad, bmeck, strRM, fgauthie, julienhenry, SamArch27, luc-tielen, XiaowenHu96, Gueckmooh)

 -- Quentin Sabah <quentin.sabah@gmail.com>  Sat, 18 Feb 2023 11:00:00 +0100

souffle (2.3) stable; urgency=low
 * Auto-scheduler for rules (SamArch27)
 * Better scheduling heuristic (julienhenry)
 * Improved component system (quentin)
 * Improved type-system for record alias (quentin)
 * Introducing include directives (quentin)
 * Optional use of libffi (quentin)
 * New packaging mechanism using souffle-lang.github.io (XiaowenHu96, mmcgr)
 * Misc fixes and refactoring (langston-barrett, aeflores, pnwamk, quentin, b-scholz, XiaowenHu96, OlivierHamel, cwarden, mbid, davidwzhao, cmuellner, luc-tielen)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Sat, 14 May 2022 22:24:08 +1000 

souffle (2.2-1) stable; urgency=low

  * Subsumption clauses, e.g., A(x1) <= A(x2) :- x1 <= x2 (@julienhenry, @b-scholz)
  * IR and build improvements (@OlivierHamel, @langston-barrett, @quentin, @b-scholz, @aeflores, @cmuellner, @broffra, @rahlk, @yihozhang, @trofi)
  * Refactoring of type analysis (@tytus-metrycki)
  * Improved packaging (@XiaowenHu96, @quentin, @uxhg, @cwarden)
  * Improved loading of DLLs (@quentin)
  * Type annotation printer (@hide-kawabata)
  * Performance improvements for eqrel (@langston-barrett, @kevzhumba)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Mon, 17 Jan 2022 12:34:01 +1100

souffle (2.1) stable; urgency=low

  * Choice domain (@XiaowenHu96)
  * Proper treatment of escape codes in symbol constants (@lyxell)
  * CSV output has rfc4180 flag for delimiters (@quentin)
  * Fix UDF syntax (@TomasPuverle)
  * Add no_magic/no_inline relational qualifiers (@sharon-wang)
  * Retire $; replace by autoinc() (@b-scholz)
  * Suppress file errors with -w flag (@b-scholz)
  * Re-implementation of the ast-to-ram translator (@azreika)
  * Added Cmake PORT support (@XiaowenHu96, @quentin
  * GitHub Action (@XiaowenHu96, @quentin, @XiaowenHu96, @b-scholz, @lyxell,@quentin,@OlivierHamel)
  * Debian Packaging and CodeCov support in GitHub Action/Cmake (@phao5814)
  * Lock-free record/symbol tables (@quentin)
  * Interpreter refactoring / fixing (@XiaowenHu96)
  * Type Analysis Refactoring (@azreika, @tytus-metrycki)
  * New SIPS strategy (@langston-berrett)
  * Refactor AST & RAM & Provenance (@TomasPuverle, @b-scholz, @azreika)
  * RAM Optimisation (@SamArch27)
  * Multiple library flag (@mclements)
  * Added “max-bound-delta” SIPS (@langston-barrett)
  * General Fixes and improvements (@b-scholz, @csabahruska, @julienhenry, @langston-berrett, @mmcgr, @TomasPuverle, @quentin,@XiaowenHu96)
  * Add fuzzing scripts with AFL and Radamsa (@langston-barrett)

 -- Bernhard Scholz <Bernhard.Scholz@sydney.edu.au>  Tue, 17 Aug 2021 12:08:04 +1100

souffle (2.0.2); urgency=low

  * Fix OSX user library paths (mmcgr)
  * Fix concurrent profling (mmcgr)
  * Fix indirect index use (aeflores)
  * Fix 'as' type conversion (darth-tytus)
  * Fix output of hint statistics (azreika)
  * Implement Record/ADT user-defined functors (darth-tytus)
  * Optimise ADT encoding (darth-tytus)
  * Added limitsize directive (b-scholz)
  * Add heuristic-based clause reordering (azreika)
  * Enhanced Magic Set transformation (azreika)
  * Restructuring for readability and maintainability (b-scholz, mmcgr)

 -- Martin McGrane <mmcgrane@it.usyd.edu.au>  Fri, 25 Sep 2020 11:10:35 +1000

souffle (2.0.1); urgency=low

  * Stop overmaterialising aggregate bodies (rdowavic)
  * Parallelise aggregate computation (rdowavic)
  * Add JSON IO (GaloisNeko)
  * Extend program minimiser (azreika)
  * Use greater precision for floating point output (mmcgr)
  * Fix duplicated symbols with multiple souffle object files (luc-tielen)
  * Fix multithreaded, interpreted, provenance (taipan-snake)
  * Fix provenance constraint explanation (taipan-snake)
  * Fix path detection for souffle tools (mmcgr)
  * Fix output directory use (mmcgr)

 -- Martin McGrane <mmcgrane@it.usyd.edu.au>  Wed, 29 Jul 2020 11:54:01 +1100

souffle (2.0.0); urgency=low

  * Added `--legacy` flag to allow use of legacy options (darth-tytus)


=== debian/control ===
Source: souffle
Maintainer: Martin McGrane <mmcgrane@it.usyd.edu.au>
Section: misc
Priority: optional
Standards-Version: 4.3.0
Build-Depends: autoconf, automake, bash-completion, bison, debhelper (>= 11), flex, g++ (>= 7), libffi-dev, libncurses5-dev, libsqlite3-dev, mcpp, sqlite3, zlib1g-dev
Homepage: https://souffle-lang.org/
Vcs-Git: https://github.com/souffle-lang/souffle.git

Package: souffle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++ (>= 7), libffi-dev, libncurses5-dev, libsqlite3-dev, mcpp, zlib1g-dev
Description: Translator of declarative Datalog programs into the C++ language.
 Soufflé is a translator of declarative Datalog programs into the C++ language.
 Soufflé is used as a domain-specific language for static program analysis, over
 large code bases with millions of lines of code. Soufflé aims to produce
 high-performance C++ code that can be compiled with the native compiler on
 the target machine.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with bash-completion

# debuild somehow finds /usr/local targets (which souffle does not use)
# and starts emitting warnings. The below code is to silence that.
override_dh_usrlocal:
